----------------------------------------------模版使用步骤--------------------------------------------------------

1. 在 Markdown 编辑器里打开模版，推荐 Typora、VSCode。
2. 先搜索“（TODO: 插件名称）”，全部替换成你的插件名称。
3. 再搜索“TODO”，按照对应说明依次修改。**修改后注意不要保留括号**。
4. 检查全文内容和样式。注意没有标 TODO 的内容由声网维护，**建议不要随意修改**。模版样式的最终效果参见[示例文档](https://docs.agora.io/cn/extension_customer/quickstart_faceunity?platform=Android)。

----------------------------------------------以下为模版正文-----------------------------------------------------

# 使用（TODO: 插件名称）插件

本文介绍如何在你的项目中集成和使用（TODO: 插件名称）插件，包括（TODO: 列举插件支持的所有平台）。

## 技术原理

（TODO: 插件名称）插件是对（TODO: 具体的 SDK 或服务） 核心 API 的封装。通过[声网视频 SDK v4.x](https://doc.shengwang.cn/doc/rtc/homepage) 的 [setExtensionProperty](https://doc.shengwang.cn/api-ref/rtc/android/API/toc_extension#api_irtcengine_setextensionproperty) 或 [setExtensionPropertyWithVendor](https://doc.shengwang.cn/api-ref/rtc/ios/API/toc_extension#api_irtcengine_setextensionproperty)方法，传入指定的 `key` 和 `value` 参数，你可以快速集成（TODO: 插件的具体能力）。

`setExtensionProperty` 和 `setExtensionPropertyWithVendor` 方法的 `key` 参数与（TODO: 厂商名称）的 API 名称完全对应，`value` 参数以 JSON 格式包装该 API 的部分或全部参数。因此，调用该方法时只要传入指定的 `key` 和 `value`，就可以调用对应的（TODO: 厂商名称） API，实现（TODO: 插件的具体能力）的有关功能。

## 前提条件

（TODO: 以下是使用声网 SDK 的版本要求，请根据插件实际情况修改或补充）

- Android 开发环境需满足以下要求：
  - Android Studio 4.1 以上版本。
  - 运行 Android 5.0 或以上版本的真机（非模拟器）。
- iOS 开发环境需满足以下要求：
  - Xcode 9.0 或以上版本。
  - 运行 iOS 9.0 或以上版本的真机（非模拟器）。

## 示例项目

（TODO: 提供每个平台示例项目的链接并说明编程语言，格式参考下表）

| 平台    | 语言        | 示例项目                            |
| :------ | :---------- | :---------------------------------- |
| Android | Java        | （TODO: 链接到 Android 工程文件夹） |
| iOS     | Objective-C | （TODO: 链接到 iOS 工程文件夹）     |

### 运行步骤

**Android**（TODO: 如果不支持 Android 平台，删除这一小节）

1. 克隆仓库：
  ```shell
	git clone （//TODO: 仓库链接）
  ```
2. 进入[声网控制台 > 云市场](https://console.agora.io/marketplace/list/all)页面，下载（TODO: 插件名称）插件的 Android 插件包。解压后，将所有 `.aar` 文件保存到 `（TODO:具体路径） ` 。
3. 在 Android Studio 中打开示例项目 `（TODO: 工程文件的路径）`。
4. 将项目与 Gradle 文件同步。
5. 打开 `（TODO: 文件的具体路径）`，进行如下修改：
	- 将 `<YOUR_APP_ID>` 替换为你的 App ID。获取 App ID 请参考[开始使用 Agora 平台](https://docs.agora.io/cn/Agora%20Platform/get_appid_token?platform=All%20Platforms)。
	- 将 `<YOUR_APP_KEY>` 和 `<YOUR_APP_SECRET>` 分别替换为你的 `appKey` 和 `appSecret`。获取方式详见[购买和激活插件](https://docs.agora.io/cn/extension_customer/get_extension?platform=All%20Platforms)。（TODO: 如果插件没有和声网打通购买和计费的自服务，删除这一条）

  ```java
  // TODO: 替换成你的插件对应的代码
  public interface Config {
       String mAppId = "<YOUR_APP_ID>";
       String mAppKey = "<YOUR_APP_KEY>";
       String mAppSecret = "<YOUR_APP_SECRET>";
  }
  ```
4. 连接一台 Android 真机（非模拟器），运行项目。

**iOS**（TODO: 如果不支持 iOS 平台，删除这一小节）

1. 克隆仓库：
  ```shell
	git clone （//TODO: 仓库链接）
  ```
2. 进入[声网控制台 > 云市场](https://console.agora.io/marketplace/list/all)页面，下载（TODO: 插件名称）插件的 iOS 插件包。解压后，将所有 `.framwork` 库文件保存到 `（TODO: 具体路径）` 。
3. 在终端中进入 `（TODO: 具体路径）`，运行以下命令使用 CocoaPods 安装依赖：
  ```
	pod install
  ```
3. 在 Xcode 中打开项目 `（TODO: 工程文件的路径）`。
4. 打开 `（TODO: 文件的具体路径）`，进行如下修改：
	- 将 `<YOUR_APP_ID>` 替换为你的 App ID。获取 App ID 请参考[开始使用 Agora 平台](https://docs.agora.io/cn/Agora%20Platform/get_appid_token?platform=All%20Platforms)。
	- 将 `<YOUR_APP_KEY>` 和 `<YOUR_APP_SECRET>` 分别替换为你的 `appKey` 和 `appSecret`。获取方式详见[购买和激活插件](https://docs.agora.io/cn/extension_customer/get_extension?platform=All%20Platforms)。（TODO: 如果插件没有和声网打通购买和计费的自服务，删除这一条）

  ```objective-c
  // TODO: 替换成你的插件对应的代码
  NSString *const appID = @"<YOUR_APP_ID>";
  NSString *const appkey = @"<YOUR_APP_KEY>";
  NSString *const secret = @"<YOUR_SECRET>";
  ```
5. 连接一台 iOS 真机（非模拟器），运行项目。

### 预期效果

（TODO: 说明安装 app 后需要在界面进行的操作，示例如下）

运行成功后，示例项目会安装到你的 Android 或 iOS 设备上。

1. 启动 app，你可以在界面上看到 `disableExtension` 和 `Start ASR` 按钮
2. 点击 `Start ASR` 开始语音转写。此时 `Start ASR` 按钮会变成 `Stop ASR` 按钮。
3. 点击 `Stop ASR` 结束语音转写。

## 集成和调用流程

### 1. 集成 SDK 和插件

开始前，你需要在项目中分别集成声网视频 SDK 和（TODO: 插件名称）插件。

#### 1.1 使用声网 SDK 实现音视频互动

（TODO: 插件名称）插件需要与 [RTC SDK](https://doc.shengwang.cn/doc/rtc/android/landing-page) 搭配使用。参考以下文档集成 RTC SDK 并实现基础的音视频互动：
- [实现音视频互动（Android）](https://doc.shengwang.cn/doc/rtc/android/get-started/quick-start)
- [实现音视频互动（iOS）](https://doc.shengwang.cn/doc/rtc/ios/get-started/quick-start)

#### 1.2 购买和激活插件

（TODO: 如果插件没有和声网打通购买和计费的自服务，请直接删除这一小节）

你需要进入[声网控制台 > 云市场](https://console.shengwang.cn/marketplace/list/all)页面，按照提示购买（TODO: 插件名称）插件。购买后需要保存好获取的 `appKey` 和 `appSecret`（TODO: 如果还有其它字段，一并补充），用于后续初始化插件时进行鉴权。

#### 1.3 集成插件

参考如下步骤在你的项目中集成（TODO: 插件名称）插件：

**Android**

（TODO: 如果插件不支持 Android，删除这一小节）

1. 在[声网云市场下载](https://docs.agora.io/cn/extension_customer/downloads?platform=All%20Platforms)页面下载（TODO: 插件名称）插件的 Android 插件包。解压后，将所有 `.aar` 文件保存到项目文件夹的  `/app/libs`  路径。（TODO:如果插件包不是 aar，可酌情修改）
2. （TODO: 如果插件还依赖其它资源，例如美颜特效插件依赖一些 bundle 文件，请在此说明如何获取这些文件、保存到项目的哪个位置。如果没有，删除这一条即可）
2. 打开 `app/build.gradle` 文件，在 `dependencies` 中添加如下行：（TODO:如果插件还有其它依赖，一并列在代码块里）
   ```java
   implementation fileTree(dir: "libs", include: ["*.jar", "*.aar"])
   ```

**iOS**

（TODO: 如果插件不支持 iOS，删除这一小节）

1. 在[声网云市场下载](https://docs.agora.io/cn/extension_customer/downloads?platform=All%20Platforms)页面下载（TODO: 插件名称）插件的 iOS 插件包。解压后，将所有 `.framework` 库文件保存到你的项目文件夹下。（TODO: 如果插件包不是 framework，可酌情修改）
2. （TODO: 如果插件还依赖其它资源，例如美颜特效插件依赖一些 bundle 文件，请在此说明如何获取这些文件、保存到项目的哪个位置。如果没有，删除这一条即可）
2. 在 Xcode 中[添加动态库](https://help.apple.com/xcode/mac/current/#/dev51a648b07)，确保 **Embed** 属性设置为 **Embed & Sign**。

以如下项目结构为例，你可以把库文件保存到 `<ProjectName>` 路径下。（TODO: 路径酌情修改）

```shell
.
├── <ProjectName>
├── <ProjectName>.xcodeproj
```

下面介绍插件相关接口的调用流程。接口的参数解释详见[接口说明]()。

### 2. 启用插件

（TODO: 说明何时调用 `addExtenion` 和 `enableExtension`/`enableExtensionWithVendor`，需要提供每个平台的示例代码。具体内容的编写可以参考[示例文档](https://docs.agora.io/cn/extension_customer/quickstart_faceunity?platform=Android)。）

### 3. 初始化插件

（TODO: 说明何时调用 `setExtensionProperty` / `setExtensionPropertyWithVendor` ，需要提供每个语言的示例代码）

### 4. （TODO: 根据插件功能补充）

（TODO: 说明 `setExtensionProperty` / `setExtensionPropertyWithVendor` 的调用时机、提供每个语言的示例代码；如果有 `onEvent` 回调返回插件事件，也需要说明）

### 5.（TODO: 根据插件功能补充）

（TODO: 同上）

## 参考信息

### API 参考

- [声网 SDK 的插件相关方法和回调](https://doc.shengwang.cn/api-ref/rtc/android/API/toc_extension)
- [插件的 key-value 说明](TODO: 链接到接口说明)

### TODO: 其它参考信息，比如错误码、素材包结构等