----------------------------------------------模版使用步骤--------------------------------------------------------

1. 在 Markdown 编辑器里打开模版，推荐 Typora、VSCode。
2. 搜索“TODO”，按照对应说明依次修改。**修改后注意不要保留括号**。
3. 检查全文内容和样式。注意没有标 TODO 的内容由声网维护，**建议不要随意修改**。模版样式的最终效果参见[示例文档](https://docs.agora.io/cn/extension_customer/api_faceunity?platform=Android)。

----------------------------------------------以下为模版正文-----------------------------------------------------

在声网 SDK 提供的插件相关方法和回调中，`key` 和 `value` 参数取决于你使用的插件。本页提供（TODO: 插件名称）插件支持的 `key` 和 `value` 说明。

## 插件的 key 概览 <a name="key-value"></a>

### 方法 key

本节列出调用声网 SDK 的 `setExtensionProperty`/`setExtensionPropertyWithVendor` 方法时，支持传入的 `key` 及对应功能。

（TODO:在表格中列出 key 的名称和描述。**每个 key 的名称都做成链接，格式为 [key名称](#全小写key名称)，这样方便跳转。** 示例如下）

| setExtensionProperty/setExtensionPropertyWithVendor 方法的 key| 描述 |
| ------------------------------------ | -------- |
| [init_speech_recognition](#init_speech_recognition)| 初始化 |
| `start_continuous_recognition_async` | 开始识别 |

### 回调 key

本节列出声网 SDK 的 `onEvent` 回调返回的 `key`。

（TODO:如果插件没有实现 onEvent 回调，删除本节即可。如果有 onEvent 回调，你需要在表格中列出 key 的名称和描述。**每个 key 的名称都做成链接，格式为 [key名称](#全小写key名称)，这样方便跳转。** 示例如下）

|onEvent 回调的 key| 描述 |
| ---------------------------- | -------------- |
| [recognized_session_stopped](#recognized_session_stopped) | 当前识别已结束 |

##  方法 key 的 value 说明

（TODO: 对于每个方法 key，用 key 的名称作三级标题，用表格列出具体的 value 参数。描述 value 参数时，需要指出参数类型。如果您的官方文档里有对应的解释，可链接到您的官方文档。下面分别是 value 包含参数和无参数的示例）

### init_speech_recognition

value 包含以下参数：

| value 参数| 描述 |
| ----------------- | ----------------------- |
| `subscription` | String 型，Azure 语音服务资源的订阅密钥。获取方式详见[免费试用语音服务](https://docs.microsoft.com/zh-cn/azure/cognitive-services/speech-service/overview#try-the-speech-service-for-free)。 |
| `region` | String 型，使用 Azure 语音服务资源的区域。获取方式详见[免费试用语音服务](https://docs.microsoft.com/zh-cn/azure/cognitive-services/speech-service/overview#try-the-speech-service-for-free)。 |

### start_continuous_recognition_async

无 value 参数。

##  回调 key 的 value 说明

（TODO: 对于每个方法 key，用 key 的名称作三级标题，用表格列出具体的 value 参数。描述 value 参数时，需要指出参数类型。如果您的官方文档里有对应的解释，可链接到您的官方文档。下面分别是 value 包含参数和无参数的示例）

### recognized_canceled

value 包含以下参数：

| value 参数 | 描述|
| ----------- | ---------------------- |
| `reason` | 取消原因。详见 [ `enum CancellationReason`](https://docs.microsoft.com/zh-cn/cpp/cognitive-services/speech/microsoft-cognitiveservices-speech-namespace#cancellationreason)。|
| `error_code`| 错误码。详见 [`enum CancellationErrorCode`](https://docs.microsoft.com/zh-cn/cpp/cognitive-services/speech/microsoft-cognitiveservices-speech-namespace#cancellationerrorcode) 。|
| `error_details` | String 型，错误信息。 |

### recognized_session_started

无 value 参数。

## 错误码

（TODO:如果插件封装的是 SDK 接口，一般可以删除本小节。如果插件封装的是服务端接口，需要用表格的形式列举所有相关的错误码，每个错误码应该有具体说明和处理方式。示例如下）

| 错误码 | 说明 | 解决方法 |
| ------ | ------- | ------------------------- |
| 0| 正确 |/|
| 401| 签名校验失败 | 检查签名是否正确 |